<?php
/*
 * Plugin: PLUGIN_NAME
 * ~~~~~~~~~~~~~~~~~~~
 * » PLUGIN_DESCRIPTION
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 */

	// Start the plugin
	$_PLUGIN = new PluginCLASSNAME();

/*
#///////////////////////////////////////////////////////////////////////#
#									#
#///////////////////////////////////////////////////////////////////////#
*/

class PluginCLASSNAME extends Plugin {
	public $config = array();

	/*
	#///////////////////////////////////////////////////////////////////////#
	#									#
	#///////////////////////////////////////////////////////////////////////#
	*/

	public function __construct () {

		// Describe the Plugin
		$this->setVersion('PLUGIN_VERSION');
		$this->setBuild('PLUGIN_BUILD');
		$this->setAuthor('AUTHORNAME');
		$this->setCopyright('PLUGIN_COPYRIGHT');
		$this->setDescription(new Message('plugin.example', 'plugin_description'));

		// Add required dependencies
		$this->addDependence('PluginLocalRecords', Dependence::REQUIRED, '1.0.0', null);
		$this->addDependence('PluginRaspJukebox', Dependence::WANTED, '1.0.0', null);

		// Register events to interact on
		$this->registerEvent('onSync', 'onSync');
		$this->registerEvent('onPlayerConnect', 'onPlayerConnect');

		// Register chat commands
		$this->registerChatCommand('hello', 'chat_hello', new Message('plugin.example', 'slash_hello_description'), Player::PLAYERS);
	}

	/*
	#///////////////////////////////////////////////////////////////////////#
	#									#
	#///////////////////////////////////////////////////////////////////////#
	*/

	public function onSync ($aseco) {

		// Read Configuration
		if (!$xml = $aseco->parser->xmlToArray('config/example.xml', true, true)) {
			trigger_error('[CLASSNAME] Could not read/parse config file "config/example.xml"!', E_USER_ERROR);
		}
		$this->config = $xml['SETTINGS'];

		// Check for settings. If missed, setup defaults.
		if ( !isset($this->config['MY_WIDGET'][0]['POS_X'][0]) ) {
			$this->config['MY_WIDGET'][0]['POS_X'][0] = -102.02;
		}
		if ( !isset($this->config['MY_WIDGET'][0]['POS_Y'][0]) ) {
			$this->config['MY_WIDGET'][0]['POS_Y'][0] = -22.025;
		}
	}

	/*
	#///////////////////////////////////////////////////////////////////////#
	#									#
	#///////////////////////////////////////////////////////////////////////#
	*/

	public function onPlayerConnect ($aseco, $player) {

		// Build message
		$message = new Message('plugin.example', 'max_records_settings');

		// Replace e.g. {1} with these entries
		$message->addPlaceholders(
			$player->nickname,
			$aseco->plugins['PluginLocalRecords']->settings['max_records']		// Demostrate handling with a Dependence::REQUIRED Plugin (without check for existence)
		);

		// sendChatMessage() does automatic replace {#highlite} and {#server} with $FFF from config/UASECO.xml <colors>
		$message->sendChatMessage($player->login);

		// Demostrate handling with a Dependence::WANTED Plugin
		if (isset($aseco->plugins['PluginRaspJukebox']) && !empty($aseco->plugins['PluginRaspJukebox']->jukebox)) {
			// Build message
			$message = new Message('plugin.example', 'maps_in_jukebox');

			// Show chat message
			$message->sendChatMessage($login);
		}
	}

	/*
	#///////////////////////////////////////////////////////////////////////#
	#									#
	#///////////////////////////////////////////////////////////////////////#
	*/

	public function chat_hello ($aseco, $login, $chat_command, $chat_parameter) {

		// Build message
		$message = new Message('plugin.example', 'slash_hello_message');

		// Show chat message
		$message->sendChatMessage($player->login);
	}
}

?>
